{ |            Cursors Unit for TurboDraw 256 Pro            | }
{ |       Programmed by Kiselev Anton (Masacre Ant)          | }
{ |"TurboDraw 256 Pro take from this Unit all it's procedures| }
{ |       and functions for drawing of cursors..."           | }
unit cursors;

INTERFACE
uses Graph,mouse;

procedure hand(x,y:integer);
procedure pen(x,y:integer);
procedure eraser(x,y:integer);
procedure spray(x,y:integer);
procedure fill(x,y:integer);
procedure tpointer(x,y:integer);
var size:longint;
    brshtype:byte;
    Dcol:byte;

IMPLEMENTATION
{Procedures of Cursors}

procedure hand(x,y:integer);
 begin
  setcolor(8);
  putpixel(x,y+7,8); putpixel(x+1,y+7,8); putpixel(x+1,y+9,8);
  putpixel(x,y+8,8); putpixel(x+1,y+10,8); putpixel(x+2,y+11,8);
  putpixel(x+2,y+12,8); putpixel(x+3,y+13,8); putpixel(x+3,y+14,8);
  putpixel(x+4,y+15,8); putpixel(x+4,y+16,8); putpixel(x+5,y+17,8);
  putpixel(x+6,y+18,8); putpixel(x+7,y+19,8); putpixel(x+7,y+20,8);
  putpixel(x+9,y+8,8); putpixel(x+12,y+8,8); putpixel(x+15,y+9,8);
  putpixel(x+16,y+6,8); putpixel(x+17,y+6,8); putpixel(x+13,y+4,8);
  putpixel(x+14,y+4,8); putpixel(x+10,y+3,8); putpixel(x+11,y+3,8);
  line(x+6,y+2,x+6,y+9);
  setcolor(0);
  line(x+2,y+7,x+5,y+10);
  putpixel(x+6,y+10,0); putpixel(x+6,y+1,0); putpixel(x+7,y,0);
  putpixel(x+8,y,0);
  line(x+9,y+1,x+9,y+7);line(x+12,y+4,x+12,y+7);line(x+15,y+5,x+15,y+8);line(x+18,y+7,x+18,y+13);
  line(x+17,y+14,x+17,y+16);line(x+16,y+17,x+16,y+18);line(x+15,y+19,x+15,y+20);
  setcolor(7);
  putpixel(x+6,y+11,7);
  line(x+8,y+1,x+8,y+7);line(x+11,y+4,x+11,y+7);
  line(x+14,y+5,x+14,y+8);line(x+17,y+7,x+17,y+13);
  line(x+16,y+14,x+16,y+16);line(x+15,y+17,x+15,y+18);
  line(x+14,y+19,x+14,y+20);line(x+2,y+8,x+5,y+11);
  setcolor(148);
  line(x+8,y+20,x+14,y+20);
  setcolor(30);SetFillStyle(1,30);
  bar(x+8,y+9,x+13,y+19);
  putpixel(x+1,y+8,30);putpixel(x+8,y+8,30);putpixel(x+11,y+8,30);
  line(x+2,y+9,x+2,y+10);line(x+3,y+10,x+3,y+12);
  line(x+4,y+11,x+4,y+14);line(x+5,y+12,x+5,y+16);
  line(x+6,y+12,x+6,y+17);line(x+7,y+1,x+7,y+18);
  line(x+10,y+4,x+10,y+8);line(x+13,y+5,x+13,y+8);
  line(x+14,y+9,x+14,y+18);line(x+15,y+10,x+15,y+16);
  line(x+16,y+7,x+16,y+13);
  setcolor(100);
 end;

procedure pen(x,y:integer);
 begin
  setcolor(Dcol);
  if brshtype=1 then rectangle(x,y,x+size,y+size);
  if brshtype=5 then
  if size=25 then circle(x+(size div 2),y+(size div 2)+1,(size div 2)-1) else
  if size>1 then circle(x+(size div 2),y+(size div 2)+1,size div 2)else circle(x+1,y+1,1);
  setcolor(100);
 end;

procedure eraser(x,y:integer);
 begin
  setcolor(Dcol+1);
   rectangle(x,y,x+size,y+size);
  SetTextStyle(2,0,4);
   outtextxy(x+2,y+2,'E');
  SetTextStyle(0,0,1);
  setcolor(100);
 end;

procedure spray(x,y:integer);
 begin
  setcolor(Dcol);
   line(x+2,y,x,y+2);line(x,y+4,x+4,y);line(x,y+6,x+5,y+1);
   line(x,y+8,x+3,y+5);line(x,y+10,x+2,y+8);line(x,y+12,x+1,y+11);
   line(x+6,y+1,x+7,y+1); putpixel(x+7,y+0,Dcol);
  setcolor(0);
   line(x+6,y+2,x+6,y+4);line(x+8,y+1,x+10,y+1);line(x+6,y+5,x+11,y+10);
   line(x+7,y+5,x+12,y+10);line(x+8,y+5,x+12,y+9);line(x+9,y+3,x+10,y+3);
   line(x+10,y+2,x+11,y+2);line(x+13,y+4,x+15,y+6);line(x+9,y+4,x+13,y+8);
   line(x+13,y+9,x+15,y+7); putpixel(x+7,y+2,0); putpixel(x+8,y+4,0);
  setcolor(Dcol);
   line(x+9,y+5,x+12,y+8);line(x+11,y+3,x+11,y+5);line(x+12,y+3,x+12,y+6);
   line(x+13,y+5,x+13,y+7);line(x+14,y+6,x+14,y+7); putpixel(x+10,y+4,Dcol);
  setcolor(100);
 end;

procedure fill(x,y:integer);
 begin
  setcolor(Dcol);
   line(x,y+4,x,y+10);line(x+1,y+3,x+1,y+12);line(x+2,y+7,x+2,y+13);
   line(x+2,y+2,x+2,y+4);line(x+3,y+2,x+3,y+3);putpixel(x+4,y+2,Dcol);
  setcolor(0);
   line(x+3,y+5,x+8,y);line(x+9,y,x+9,y+1);line(x+10,y+2,x+11,y+2);
   line(x+3,y+6,x+4,y+6);line(x+5,y+7,x+5,y+8);line(x+6,y+9,x+12,y+3);
   line(x+7,y+9,x+12,y+4);line(x+7,y+10,x+13,y+4);line(x+8,y+10,x+13,y+5);
   line(x+8,y+11,x+14,y+5);
   line(x+10,y+12,x+15,y+7);putpixel(x+9,y+12,0);putpixel(x+15,y+6,0);
   putpixel(x+9,y+3,0);putpixel(x+6,y+6,0);
  setcolor(Dcol);
   line(x+5,y+4,x+10,y+4);line(x+4,y+5,x+9,y+5);line(x+7,y+6,x+8,y+6);
   line(x+6,y+7,x+7,y+7);line(x+9,y+11,x+14,y+6);line(x+10,y+11,x+14,y+7);
   putpixel(x+5,y+6,Dcol);putpixel(x+6,y+8,Dcol);
  setcolor(100);
 end;

procedure tpointer(x,y:integer);
 begin
  setcolor(56);
   line(x,y+5,x+10,y+5);
   line(x+5,y,x+5,y+10);
  setcolor(100);
 end;

begin
end.


