program tdi2bmp;

{$APPTYPE CONSOLE}

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls;

var
currentColor : TColor;
Bitmap: TBitmap;
f:text;
fname:string;
x,y:integer;
bmp_wdth,bmp_hght,col:longint;

begin
 writeln('================================================');
 writeln('||TurboDraw256 Image Converter from TDI to BMP||');
 writeln('||     Code: Kiselev Anton (Masacre Ant)      ||');
 writeln('||  Read TurboDraw Help for more information  ||');
 writeln('================================================');
 writeln;
 write('Type file name (without extension) : ');
 readln(fname);
 Assign(f,fname+'.TDI');
 Reset(f);
 try
 Bitmap:=TBitmap.Create;
 //Bitmap.LoadFromFile(fname+'.bmp');

 Readln(f,bmp_wdth,bmp_hght);

 Bitmap.width:=bmp_wdth;
 Bitmap.Height:=bmp_hght;

 while not eof(f) do
  begin
   readln(f,x,y,col);
   case col of
    1:currentColor:=$00AA0000;
    2:currentColor:=$0000AA00;
    3:currentColor:=$00AAAA00;
    4:currentColor:=$000000AA;
    5:currentColor:=$00AA00AA;

    6:currentColor:=$000055AA;
    7:currentColor:=$00AAAAAA;
    8:currentColor:=$00555555;
    9:currentColor:=$00FF5555;
    10:currentColor:=$0055FF55;

    11:currentColor:=$00FFFF55;
    12:currentColor:=$005555FF;
    13:currentColor:=$00FF55FF;
    14:currentColor:=$0055FFFF;
    15:currentColor:=$FFFFFF;

    16:currentColor:=$000000;
    17:currentColor:=$00141414;
    18:currentColor:=$00202020;
    19:currentColor:=$002C2C2C;
    20:currentColor:=$00383838;

    21:currentColor:=$00454545;
    22:currentColor:=$00515151;
    23:currentColor:=$00616161;
    24:currentColor:=$00717171;
    25:currentColor:=$00828282;

    26:currentColor:=$00929292;
    27:currentColor:=$00A2A2A2;
    28:currentColor:=$00B6B6B6;
    29:currentColor:=$00CBCBCB;
    30:currentColor:=$00E3E3E3;

    32:currentColor:=$FF0000;
    33:currentColor:=$00FF0041;
    34:currentColor:=$00FF0080;
    35:currentColor:=$00FF00BE;
    36:currentColor:=$FF00FF;

    37:currentColor:=$00BE00FF;
    38:currentColor:=$007D00FF;
    39:currentColor:=$004100FF;
    40:currentColor:=$0000FF;
    41:currentColor:=$000041FF;

    42:currentColor:=$00007DFF;
    43:currentColor:=$0000BEFF;
    44:currentColor:=$00FFFF;
    45:currentColor:=$0000FFBE;
    46:currentColor:=$0000FF7D;

    47:currentColor:=$0000FF41;
    48:currentColor:=$00FF00;
    49:currentColor:=$0041FF00;
    50:currentColor:=$007DFF00;
    51:currentColor:=$00BEFF00;

    52:currentColor:=$00FFFF00;
    53:currentColor:=$00FFBE00;
    54:currentColor:=$00FF7D00;
    55:currentColor:=$00FF4100;
    56:currentColor:=$00FF7D7D;

    57:currentColor:=$00FF7D9E;
    58:currentColor:=$00FF7DBE;
    59:currentColor:=$00FF7DDF;
    60:currentColor:=$00FF7DFF;
    61:currentColor:=$00DF7DFF;

    62:currentColor:=$00BE7DFF;
    63:currentColor:=$009E7DFF;
    64:currentColor:=$007D7DFF;
    65:currentColor:=$007D9EFF;
    66:currentColor:=$007DBEFF;

    67:currentColor:=$007DDFFF;
    68:currentColor:=$007DFFFF;
    69:currentColor:=$007DFFDF;
    70:currentColor:=$007DFFBE;
    71:currentColor:=$007DFF9E;

    72:currentColor:=$007DFF7D;
    73:currentColor:=$009EFF7D;
    74:currentColor:=$00BEFF7D;
    75:currentColor:=$00DFFF7D;
    76:currentColor:=$00FFFF7D;

    77:currentColor:=$00FFDF7D;
    78:currentColor:=$00FFBE7D;
    79:currentColor:=$00FF9E7D;
    80:currentColor:=$00FFB6B6;
    81:currentColor:=$00FFB6C7;

    82:currentColor:=$00FFB6DB;
    83:currentColor:=$00FFB6EB;
    84:currentColor:=$00FFB6FF;
    85:currentColor:=$00EBB6FF;
    86:currentColor:=$00DBB6FF;

    87:currentColor:=$00C7B6FF;
    88:currentColor:=$00B6B6FF;
    89:currentColor:=$00B6C7FF;
    90:currentColor:=$00B6DBFF;
    91:currentColor:=$00B6EBFF;

    92:currentColor:=$00B6FFFF;
    93:currentColor:=$00B6FFEB;
    94:currentColor:=$00B6FFDB;
    //load
    95:currentColor:=$00B6FFC7;
    96:currentColor:=$00B6FFB6;

    97:currentColor:=$00C7FFB6;
    98:currentColor:=$00DBFFB6;
    99:currentColor:=$00EBFFB6;
    100:currentColor:=$00FFFFB6;
    101:currentColor:=$00FFEBB6;

    102:currentColor:=$00FFDBB6;
    103:currentColor:=$00FFC7B6;
    104:currentColor:=$00710000;
    105:currentColor:=$0071001C;
    106:currentColor:=$00710038;

    107:currentColor:=$00710055;
    108:currentColor:=$00710071;
    109:currentColor:=$00550071;
    110:currentColor:=$00380071;
    111:currentColor:=$001C0071;

    112:currentColor:=$00000071;
    113:currentColor:=$00001C71;
    114:currentColor:=$00003871;
    115:currentColor:=$00005571;
    116:currentColor:=$00007171;

    117:currentColor:=$00007155;
    118:currentColor:=$00007138;
    119:currentColor:=$0000711C;
    120:currentColor:=$00007100;
    121:currentColor:=$001C7100;

    122:currentColor:=$00387100;
    123:currentColor:=$00557100;
    124:currentColor:=$00717100;
    125:currentColor:=$00715500;
    126:currentColor:=$00713800;

    127:currentColor:=$00711C00;
    128:currentColor:=$00713838;
    129:currentColor:=$00713845;
    130:currentColor:=$00713855;
    131:currentColor:=$00713861;

    132:currentColor:=$00713871;
    133:currentColor:=$00613871;
    134:currentColor:=$00553871;
    135:currentColor:=$00453871;
    136:currentColor:=$00383871;

    137:currentColor:=$00384571;
    138:currentColor:=$00385571;
    139:currentColor:=$00386171;
    140:currentColor:=$00387171;
    141:currentColor:=$00387161;

    142:currentColor:=$00387155;
    143:currentColor:=$00387145;
    144:currentColor:=$00387138;
    145:currentColor:=$00457138;
    146:currentColor:=$00557138;

    147:currentColor:=$00617138;
    148:currentColor:=$00717138;
    149:currentColor:=$00716138;
    150:currentColor:=$00715538;
    151:currentColor:=$00714538;

    152:currentColor:=$00715151;
    153:currentColor:=$00715159;
    154:currentColor:=$00715161;
    155:currentColor:=$00715169;
    156:currentColor:=$00715171;

    157:currentColor:=$00695171;
    158:currentColor:=$00615171;
    159:currentColor:=$00595171;
    160:currentColor:=$00515171;
    161:currentColor:=$00515971;

    162:currentColor:=$00516171;
    163:currentColor:=$00516971;
    164:currentColor:=$00517171;
    165:currentColor:=$00517169;
    166:currentColor:=$00517161;

    167:currentColor:=$00517159;
    168:currentColor:=$00517151;
    169:currentColor:=$00597151;
    170:currentColor:=$00617151;
    171:currentColor:=$00697151;

    172:currentColor:=$00717151;
    173:currentColor:=$00716951;
    174:currentColor:=$00716151;
    175:currentColor:=$00715951;
    176:currentColor:=$00410000;

    177:currentColor:=$00410010;
    178:currentColor:=$00410020;
    179:currentColor:=$00410030;
    180:currentColor:=$00410041;
    181:currentColor:=$00300041;

    182:currentColor:=$00200041;
    183:currentColor:=$00100041;
    184:currentColor:=$00000041;
    185:currentColor:=$00001041;
    186:currentColor:=$00002041;

    187:currentColor:=$00003041;
    188:currentColor:=$00004141;
    189:currentColor:=$00004130;
    190:currentColor:=$00004120;
    191:currentColor:=$00004110;

    192:currentColor:=$00004100;
    193:currentColor:=$00104100;
    194:currentColor:=$00204100;
    195:currentColor:=$00304100;
    196:currentColor:=$00414100;

    197:currentColor:=$00413000;
    198:currentColor:=$00412000;
    199:currentColor:=$00411000;
    200:currentColor:=$00412020;
    201:currentColor:=$00412028;

    202:currentColor:=$00412030;
    203:currentColor:=$00412038;
    204:currentColor:=$00412041;
    205:currentColor:=$00382041;
    206:currentColor:=$00302041;

    207:currentColor:=$00282041;
    208:currentColor:=$00202041;
    209:currentColor:=$00202841;
    210:currentColor:=$00203041;
    211:currentColor:=$00203841;

    212:currentColor:=$00204141;
    213:currentColor:=$00204138;
    214:currentColor:=$00204130;
    215:currentColor:=$00204128;
    216:currentColor:=$00204120;

    217:currentColor:=$00284120;
    218:currentColor:=$00304120;
    219:currentColor:=$00384120;
    220:currentColor:=$00414120;
    221:currentColor:=$00413820;

    222:currentColor:=$00413020;
    223:currentColor:=$00412820;
    224:currentColor:=$00412C2C;
    225:currentColor:=$00412C30;
    226:currentColor:=$00412C34;

    227:currentColor:=$00412C3C;
    228:currentColor:=$00412C41;
    229:currentColor:=$003C2C41;
    230:currentColor:=$00342C41;
    231:currentColor:=$00302C41;

    232:currentColor:=$002C2C41;
    233:currentColor:=$002C3041;
    234:currentColor:=$002C3441;
    235:currentColor:=$002C3C41;
    236:currentColor:=$002C4141;

    237:currentColor:=$002C413C;
    238:currentColor:=$002C4134;
    239:currentColor:=$002C4130;
    240:currentColor:=$002C412C;
    241:currentColor:=$0030412C;

    242:currentColor:=$0034412C;
    243:currentColor:=$003C412C;
    244:currentColor:=$0041412C;
    245:currentColor:=$00413C2C;
    246:currentColor:=$0041342C;
   end;
   Bitmap.Canvas.Pixels[x,y]:=currentColor;
  end;

 Bitmap.SaveToFile(fname+'.bmp');

 writeln('File was succesfully converted, BMP file name - ',fname,'.bmp')
 except
 writeln('Error!!! Source file doesnt founded in converter root directory...');
 end;

 Bitmap.free;
 Close(f);

writeln('Press Any Key For Exit...');
readln;
end.
