{ |          Resources Unit for TurboDraw 256 Pro            | }
{ |       Programmed by Kiselev Anton (Masacre Ant)          | }
{ |"TurboDraw 256 Pro take from this Unit all it's procedures| }
{ |                   and functions..."                      | }

unit resources;

 INTERFACE
  uses Mouse,Graph,CRT,gcrt,cursors;

   var col,scol,brprop,brush:byte; directory:string;
       radis:integer;
       savebufer,savedfile,loadedfile:text;
       s1,s2,s3,s4,s5,s6:integer;
       mbtnpressed,blocked,rnge1,rnge2:boolean;
       srangex1,srangey1,srangex2,srangey2:integer;
       tcursor,bmask1,bmask2,bmask3,bmask4:pointer; crntcursor:string;
       dspX,dspY:byte;
   procedure onload;
   procedure backinterface;
   procedure palitra;
   procedure mousecoord;
   procedure checkcolor;
   procedure draw;
   procedure choisebrush;
   procedure pechatat;
   procedure saving;
   procedure loading;
   procedure crntcur;
   procedure extsave(zsx,zsy,zex,zey:integer);
   procedure extloading(zsx,zsy:integer);
   procedure draw_tdi(nm:string; drx,dry,trns:integer);
   procedure getsaverange(dot:byte);
   procedure takeamemory(x1,y1,x2,y2:integer);
   procedure cursor(wdth,hght,dly:integer);
   procedure get_curdisp;
   procedure fast_optimize;
   procedure make_bmask;
   procedure clip_canvas(fill:boolean);



 IMPLEMENTATION

 procedure make_bmask;
  var bmsize:integer;
  begin
   bmsize:=imagesize(45,25,524,44);
   getmem(bmask1,bmsize);
   getimage(45,23,524,44,bmask1^);

   bmsize:=imagesize(45,406,535,436);
   getmem(bmask2,bmsize);
   getimage(45,406,535,436,bmask2^);

   bmsize:=imagesize(506,25,536,436);
   getmem(bmask3,bmsize);
   getimage(506,25,536,436,bmask3^);

   bmsize:=imagesize(20,445,130,460);
   getmem(bmask4,bmsize);
   getimage(20,445,130,460,bmask4^);
  end;

  procedure clip_canvas(fill:boolean);
   begin
     SetFillStyle(1,19);
     Bar(45,34,515,44);
     Bar(20,35,44,425);
     Bar(45,406,505,416);
     Bar(506,25,516,416);
     Line(45,45,505,45);
     Line(45,45,45,405);
     Line(45,405,505,405);
     Line(505,45,505,405);

   if brprop>15 then
    begin
    if mousey<61 then
    putimage(45,23,bmask1^,copyput);

    if mousey>389 then
    putimage(45,406,bmask2^,copyput);

    if mousex>491 then
    putimage(506,25,bmask3^,copyput);
    end;

   if fill then begin
    putimage(45,23,bmask1^,copyput);
    putimage(45,406,bmask2^,copyput);
    putimage(506,25,bmask3^,copyput);
   end;
   end;

 procedure fast_optimize;
  var temp_f:text;
      str:string;
      pcol,pscol,pbrush,px,py,col,scol,brush,x,y,brprop,pbrprop:integer;
   begin
    close(savebufer);
    assign(temp_f,'tempf.buf');

    rewrite(temp_f);
    reset(savebufer);
    readln(savebufer,pbrush,pcol,px,py,pbrprop,pscol);
    writeln(temp_f,pbrush,' ',pcol,' ',px,' ',py,' ',pbrprop,' ',pscol);
     while not eof(savebufer) do
      begin
       readln(savebufer,brush,col,x,y,brprop,scol);
       if (pbrush<>brush)or(pcol<>col)or(px<>x)or(py<>y)or(pbrprop<>brprop)or(pscol<>scol) then
        begin
         writeln(temp_f,brush,' ',col,' ',x,' ',y,' ',brprop,' ',scol);
         pbrush:=brush; pcol:=col; px:=x; py:=y; pbrprop:=brprop; pscol:=scol;
        end;
      end;
    close(savebufer);
    append(savebufer);
   end;

 procedure draw_tdi(nm:string; drx,dry,trns:integer);
  var i,pixcolor,px,py:integer;
  begin
   Assign(loadedfile,nm);
   {$I-}
   reset(loadedfile);
   {$I+}
    if IOResult=0 then begin

     readln(loadedfile);

     while not eof(loadedfile) do
      begin
       readln(loadedfile,px,py,pixcolor);
       if pixcolor<>trns then  putpixel(drx+px,dry+py,pixcolor);
      end;

   Close(loadedfile);
    end;
  end;

 procedure onload;
  var stop:boolean;
      i:integer;
      img:byte;
   begin
    stop:=false;
    crntcursor:='hand';
    SetMouseRange(10,10,614,458);
    TakeaMemory(0,0,25,25);
    randomize;
    img:=random(3);

    setfillstyle(1,19);
    floodfill(1,1,19);
    draw_tdi('logo.TDI',120,10,15);
    case img of
     0:draw_tdi('image1.TDI',170,110,-1);
     1:draw_tdi('image2.TDI',170,110,-1);
     2:draw_tdi('image3.TDI',170,110,-1);
     4:draw_tdi('image4.TDI',170,110,-1);
    end;
    draw_tdi('button.TDI',280,400,-1);
     for i:=0 to 14 do
      begin
       draw_tdi('border.TDI',0,i*32,15);
      end;
     for i:=0 to 14 do
      begin
       draw_tdi('border.TDI',608,i*32,15);
      end;

    setcolor(16);
    outtextxy(250,460,'Powered by Ant-Ware.');
    outtextxy(150,470,'Programmed by Kiselev Anton ("Masacre Ant").');

    while stop=false do
     begin
      readmouse;
      get_curdisp;
      GetImage(mousex-dspx,mousey-dspy,mousex-dspx+25, mousey-dspy+25, tcursor^);
      cursor(25,25,500);
      PutImage(mousex-dspx,mousey-dspy,tcursor^,CopyPut);

      if (MouseX>280) and (MouseX<357)  then
      if (MouseY>400) and (MouseY<442) then
       if LeftButtonPressed then stop:=true;
     end;
    cleardevice;

   end;


 procedure takeamemory(x1,y1,x2,y2:integer);
  begin
   GetMem(tcursor,ImageSize(x1,y1,x2,y2));
  end;


 procedure get_curdisp;
  begin
    if crntcursor='hand' then begin dspx:=7; dspy:=0; end;
    if crntcursor='pen' then begin dspx:=round(brprop/2); dspy:=round(brprop/2); end;
    if crntcursor='eraser' then begin dspx:=round(brprop/2); dspy:=round(brprop/2); end;
    if crntcursor='spray' then begin dspx:=0; dspy:=10; end;
    if crntcursor='fill' then begin dspx:=2; dspy:=13; end;
    if crntcursor='pointer' then begin dspx:=5; dspy:=5; end;
  end;


 procedure cursor(wdth,hght,dly:integer);
  begin
   {drawing of cursor}
    size:=brprop;
    brshtype:=brush;
    Dcol:=col;
    if crntcursor='hand' then hand(mousex-dspx,mousey-dspy);
    if crntcursor='pen' then pen(mousex-dspx,mousey-dspy);
    if crntcursor='eraser' then eraser(mousex-dspx,mousey-dspy);
    if crntcursor='spray' then spray(mousex-dspx,mousey-dspy);
    if crntcursor='fill' then fill(mousex-dspx,mousey-dspy);
    if crntcursor='pointer' then tpointer(mousex-dspx,mousey-dspy);
   {ended}
  Delay(dly);
  end;


 procedure crntcur;
   begin
     if (MouseX>50) and (MouseX<500)  then
     if (MouseY>50) and (MouseY<400) then
       begin
        if (brush=1)or(brush=5) then crntcursor:='pen';{pen}
        if brush=4 then crntcursor:='eraser';{eraser}
        if brush=2 then crntcursor:='spray';{spray}
        if brush=3 then crntcursor:='fill';{fill}
        if blocked=true then crntcursor:='pointer';{pointer}
        end;
     if (MouseX<50) or (MouseX>500)  then crntcursor:='hand';{hand}
     if (MouseY<50) or (MouseY>400) then crntcursor:='hand';{hand}
   end;

{-----Interface Procedures-----}
 procedure backinterface;
 var i:byte;
  begin
   SetFillStyle (1,19);
      FloodFill(0,0,19);
      draw_tdi('menu.TDI',1,417,36);
      draw_tdi('logo2.TDI',160,3,36);
    end;

 procedure palitra;
  var i,j:integer;
  begin
   draw_tdi('menu2.TDI',525,0,36);
      setcolor (26);
   {Main Col Pal column}
      SetFillStyle(1,19);
        bar(526,18,620,174);
       rectangle(526,18,620,174);
     for j:= 0 to 16 do
     for i:= 1 to 15 do begin
      SetFillStyle(1,(j*15)+i);
        bar(522+(6*i),20+(9*j),522+(6*i)+6,28+(9*j));
      end;
  {work place}
   SetFillStyle(1,29);
        Bar3D(45,45,505,405, 0, TopOn);

   {Draw chose of brush parametres}
   draw_tdi('sizes.TDI',516,332,36);
  end;
{-----End of Interface Procedures-----}

{---------Other Procedures---------}
 procedure mousecoord;
 var mx,my,ccol,sccol,pix:string;
  begin
      str (MouseX,mx);
      str (MouseY,my);
      str (col,ccol);
      str (scol,sccol);
      str (GetPixel(MouseX,MouseY),pix);
   SetFillStyle(1,19);
       bar(0,0,60,40);
       bar(0,40,40,50);
       outtextxy(10,3,'x:'+mx);
       outtextxy(10,13,'y:'+my);
       outtextxy(10,23,'c1:'+ccol);
       outtextxy(10,33,'c2:'+sccol);
       outtextxy(10,43,pix);
  end;

 procedure checkcolor;
  begin
   {second column}
    if (MouseX>526) and (MouseX<620) then
    if (MouseY>18)   and (MouseY<174) then  begin
      if LeftButtonPressed then col:=getpixel(mousex,mousey-1);
      if RightButtonPressed then scol:=getpixel(mousex,mousey-1); end;
   {draw choosed colors}
    if (MouseX>526) and (MouseX<620) then
    if (MouseY>18) and (MouseY<174) then
      if (LeftButtonPressed)or(RightButtonPressed) then begin
    SetFillStyle(1,scol);
        Bar3D(555,435,585,465,0,TopOff);
    SetFillStyle(1,col);
        Bar3D(540,420,570,450,0,TopOff);
         end;
  end;

 procedure draw;
 var i:integer;
  begin
    if brush=1 then begin
     if LeftButtonPressed then SetFillStyle(1,col);
     if RightButtonPressed then SetFillStyle(1,scol);
        if (brprop<>1)and(brprop<>3)and(brprop<>5) then
         bar (MouseX-(brprop div 2),MouseY-(brprop div 2),MouseX+(brprop div 2),MouseY+(brprop div 2));
        if (brprop=1)or(brprop=3)or(brprop=5) then
         bar (MouseX,MouseY,MouseX+brprop,MouseY+brprop);
       end;
    if brush=2 then begin
       randomize;
      for i:= 1 to 3 do begin
        if LeftButtonPressed then begin
         putpixel(MouseX+random(brprop+5),MouseY+random(brprop+5),col);
         putpixel(MouseX-random(brprop+5),MouseY-random(brprop+5),col);
         putpixel(MouseX-random(brprop+5),MouseY+random(brprop+5),col);
         putpixel(MouseX+random(brprop+5),MouseY-random(brprop+5),col);
           end;
        if RightButtonPressed then begin
         putpixel(MouseX+random(brprop+5),MouseY+random(brprop+5),scol);
         putpixel(MouseX-random(brprop+5),MouseY-random(brprop+5),scol);
         putpixel(MouseX-random(brprop+5),MouseY+random(brprop+5),scol);
         putpixel(MouseX+random(brprop+5),MouseY-random(brprop+5),scol);
           end;
         end;
       end;
    if brush=3 then begin
     setcolor(scol);
      {main fill actions}
       rectangle(45,45,505,405);
       SetFillStyle(1,col);
       if mbtnpressed=false then FloodFill(mousex,mousey,scol);
      {end}
     setcolor(100);
     mbtnpressed:=true;
       end;
    if brush=4 then begin
     SetFillStyle(1,29);
        if (brprop<>1)and(brprop<>3)and(brprop<>5) then
         bar (MouseX-(brprop div 2),MouseY-(brprop div 2),MouseX+(brprop div 2),MouseY+(brprop div 2));
        if (brprop=1)or(brprop=3)or(brprop=5) then
         bar (MouseX,MouseY,MouseX+brprop,MouseY+brprop);
       end;
    if brush=5 then begin
     radis:=brprop;
     if (LeftButtonPressed) then begin setfillstyle(1,col); setcolor(col); end;
     if (RightButtonPressed)and not(LeftButtonPressed) then begin setfillstyle(1,scol); setcolor(scol); end;
       pieslice(MouseX,MouseY,0,360,brprop);
     setcolor(100);
       end;
 {***Cutting of image***}
   clip_canvas(false);

 {**Write current canvas info in savebufer**}
     if LeftButtonPressed then writeln (savebufer,brush,' ',col,' ',MouseX,' ',MouseY,' ',brprop,' ',scol);
     if RightButtonPressed then writeln (savebufer,brush,' ',scol,' ',MouseX,' ',MouseY,' ',brprop,' ',col);
  end;

 procedure  choisebrush;
  begin
    if (MouseX>558) and (MouseX<579) then
    if (MouseY>191) and (MouseY<212) then
      if LeftButtonPressed then brush:=1;
    if (MouseX>580) and (MouseX<601) then
    if (MouseY>191) and (MouseY<212) then
      if LeftButtonPressed then brush:=5;
    if (MouseX>558) and (MouseX<579) then
    if (MouseY>214) and (MouseY<235) then
      if LeftButtonPressed then brush:=2;
    if (MouseX>580) and (MouseX<601) then
    if (MouseY>214) and (MouseY<235) then
      if LeftButtonPressed then brush:=3;
    if (MouseX>580) and (MouseX<601) then
    if (MouseY>237) and (MouseY<258) then
      if LeftButtonPressed then brush:=4;
  {choise a brush properties}
    if (MouseX>520) and (MouseX<540) then
    if (MouseY>374) and (MouseY<394) then
      if LeftButtonPressed then brprop:=7;
    if (MouseX>542) and (MouseX<562) then
    if (MouseY>374) and (MouseY<394) then
      if LeftButtonPressed then brprop:=10;
    if (MouseX>564) and (MouseX<584) then
    if (MouseY>374) and (MouseY<394) then
      if LeftButtonPressed then brprop:=15;
    if (MouseX>586) and (MouseX<606) then
    if (MouseY>374) and (MouseY<394) then
      if LeftButtonPressed then brprop:=20;
    if (MouseX>608) and (MouseX<630) then
    if (MouseY>374) and (MouseY<394) then
      if LeftButtonPressed then brprop:=25;
    if (MouseX>520) and (MouseX<540) then
    if (MouseY>350) and (MouseY<370) then
      if LeftButtonPressed then brprop:=1;
    if (MouseX>542) and (MouseX<562) then
    if (MouseY>350) and (MouseY<370) then
      if LeftButtonPressed then brprop:=2;
    if (MouseX>564) and (MouseX<584) then
    if (MouseY>350) and (MouseY<370) then
      if LeftButtonPressed then brprop:=3;
    if (MouseX>586) and (MouseX<606) then
    if (MouseY>350) and (MouseY<370) then
      if LeftButtonPressed then brprop:=4;
    if (MouseX>608) and (MouseX<630) then
    if (MouseY>350) and (MouseY<370) then
      if LeftButtonPressed then brprop:=5;
  end;

 procedure pechatat;
  begin
     putimage(20,445,bmask4^,copyput);
     SetTextStyle(2,0,4);
        setcolor(73);
     {call a procedure of gcrt}
         stx:=20; sty:=447;
         maxch:=7;
         listing:=false;
         rashirenie:='tdi';
         stopkey:=#13;

         pechat;

     {close a procedure of gcrt}
     key:='0';
     SetTextStyle(0,0,1);
  end;

 procedure saving;
  var bbuf:text;
  begin
   GetDir(0,directory);
   Assign(bbuf,'tempf.buf');
   Assign(savedfile,name);
   reset(bbuf);
    ChDir('..\images');
    rewrite(savedfile);
    ChDir(directory);

     while not Eof(bbuf) do
      begin
       readln(bbuf,s1,s2,s3,s4,s5,s6);
       writeln(savedfile,s1,' ',s2,' ',s3,' ',s4,' ',s5,' ',s6);
      end;

   Close(savedfile);
   Close(bbuf);
   Erase(bbuf);
  end;

 procedure extsave(zsx,zsy,zex,zey:integer);
  var i,j,pixcol:integer;
  begin
   GetDir(0,directory);
   Assign(savedfile,name);
    ChDir('..\extimgs');
    rewrite(savedfile);
    ChDir(directory);

     writeln(savedfile,srangex2-srangex1,' ',srangey2-srangey1);

     for i:= 0 to (zex-zsx) do
      for j:= 0 to (zey-zsy) do
       begin
        pixcol:=getpixel(zsx+i,zsy+j);
        writeln(savedfile,i,' ',j,' ',pixcol,' ');
       end;

   Close(savedfile);
  end;

 procedure extloading(zsx,zsy:integer);
 var i,pixcolor,px,py:integer;
  begin
   GetDir(0,directory);
   Assign(loadedfile,name);
   {$I-}
   ChDir('..\extimgs');
   reset(loadedfile);
   ChDir(directory);
   {$I+}
    if IOResult=0 then begin

     readln(loadedfile);

     while not eof(loadedfile) do
      begin
       readln(loadedfile,px,py,pixcolor);
       if (px<460)AND(py<360) then
       putpixel(zsx+px,zsy+py,pixcolor);
      end;

    {***Cutting of image***}
     clip_canvas(true);

   Close(loadedfile);
    end else begin
     putimage(20,445,bmask4^,copyput);
     SetTextStyle(2,0,4);
      setcolor(40);
       outtextxy(25,447,'File not found!');
      setcolor(100);
     SetTextStyle(0,0,1);
    end;
  end;


 procedure loading;
 var i:integer;
  begin
   GetDir(0,directory);
   Assign(loadedfile,name);
   {$I-}
   ChDir('..\images');
   reset(loadedfile);
   ChDir(directory);
   {$I+}
    if IOResult=0 then begin
     while not Eof(loadedfile) do
      begin
       readln(loadedfile,s1,s2,s3,s4,s5,s6);
       writeln(savebufer,s1,' ',s2,' ',s3,' ',s4,' ',s5,' ',s6);

        if s1=1 then begin
          SetFillStyle(1,s2);
        if (s5<>1)and(s5<>3)and(s5<>5) then
          bar (s3-(s5 div 2),s4-(s5 div 2),s3+(s5 div 2),s4+(s5 div 2));
        if (s5=1)or(s5=3)or(s5=5) then
         bar (s3,s4,s3+s5,s4+s5);
        end;

        if s1=2 then begin
           randomize;
          for i:= 1 to 3 do begin
             putpixel(s3+random(s5+5),s4+random(s5+5),s2);
             putpixel(s3-random(s5+5),s4-random(s5+5),s2);
             putpixel(s3-random(s5+5),s4+random(s5+5),s2);
             putpixel(s3+random(s5+5),s4-random(s5+5),s2);
              end;
        end;

        if s1=3 then begin
          setcolor(s6);
           {main fill actions}
             rectangle(45,45,505,405);
            SetFillStyle(1,s2);
            FloodFill(s3,s4,s6);
            {end}
          setcolor(100);
        end;

        if s1=4 then begin
          SetFillStyle(1,29);
             if (s5<>1)and(s5<>3)and(s5<>5) then
              bar (s3-(s5 div 2),s4-(s5 div 2),s3+(s5 div 2),s4+(s5 div 2));
             if (s5=1)or(s5=3)or(s5=5) then
              bar (s3,s4,s3+s5,s4+s5);
        end;

        if s1=5 then begin
          setfillstyle(1,s2);
          setcolor(s2);
           pieslice(s3,s4,0,360,s5);
          setcolor(100);
        end;
      end;
    {***Cutting of image***}
     clip_canvas(true);
   Close(loadedfile);
    end else begin
     putimage(20,445,bmask4^,copyput);
     SetTextStyle(2,0,4);
      setcolor(64);
       outtextxy(25,447,'File not found!');
      setcolor(100);
     SetTextStyle(0,0,1);
    end;
  end;

 Procedure getsaverange(dot:byte);
  begin
   if dot=1 then begin
      putpixel(mousex-1,mousey-1,40);
      srangex1:=mousex;
      srangey1:=mousey;
      rnge1:=true;end;
   if dot=2 then
   if (mousex>srangex1)and(mousey>srangey1) then begin
      srangex2:=mousex;
      srangey2:=mousey;
      setcolor(40);
      rectangle(srangex1-1,srangey1-1,srangex2+1,srangey2+1);
      setcolor(100);
      rnge2:=true;end;
  end;

begin
end.