program bmp2tdi;

{$APPTYPE CONSOLE}

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls;

var
currentColor : TColor;
Bitmap: TBitmap;
f:text;
fname:string;
bmp_wdth,bmp_hght,i,j:longint;

begin
 writeln('================================================');
 writeln('||TurboDraw256 Image Converter from BMP to TDI||');
 writeln('||     Code: Kiselev Anton (Masacre Ant)      ||');
 writeln('||  Read TurboDraw Help for more information  ||');
 writeln('================================================');
 writeln;
 write('Type file name (without extension) : ');
 readln(fname);
 Assign(f,fname+'.TDI');
 Rewrite(f);
 try
 Bitmap:=TBitmap.Create;
 Bitmap.LoadFromFile(fname+'.bmp');

 bmp_wdth:=Bitmap.width;
 bmp_hght:=Bitmap.Height;

 writeln(f,bmp_wdth,' ',bmp_hght);

 for i:= 0 to bmp_wdth do
 for j:=0 to bmp_hght do
  begin
   currentColor:=Bitmap.Canvas.Pixels[i,j];
   case currentColor of
    $00AA0000:writeln(f,i,' ',j,' ',1,' ');
    $0000AA00:writeln(f,i,' ',j,' ',2,' ');
    $00AAAA00:writeln(f,i,' ',j,' ',3,' ');
    $000000AA:writeln(f,i,' ',j,' ',4,' ');
    $00AA00AA:writeln(f,i,' ',j,' ',5,' ');

    $000055AA:writeln(f,i,' ',j,' ',6,' ');
    $00AAAAAA:writeln(f,i,' ',j,' ',7,' ');
    $00555555:writeln(f,i,' ',j,' ',8,' ');
    $00FF5555:writeln(f,i,' ',j,' ',9,' ');
    $0055FF55:writeln(f,i,' ',j,' ',10,' ');

    $00FFFF55:writeln(f,i,' ',j,' ',11,' ');
    $005555FF:writeln(f,i,' ',j,' ',12,' ');
    $00FF55FF:writeln(f,i,' ',j,' ',13,' ');
    $0055FFFF:writeln(f,i,' ',j,' ',14,' ');
    $FFFFFF:writeln(f,i,' ',j,' ',15,' ');

    $000000:writeln(f,i,' ',j,' ',16,' ');
    $00141414:writeln(f,i,' ',j,' ',17,' ');
    $00202020:writeln(f,i,' ',j,' ',18,' ');
    $002C2C2C:writeln(f,i,' ',j,' ',19,' ');
    $00383838:writeln(f,i,' ',j,' ',20,' ');

    $00454545:writeln(f,i,' ',j,' ',21,' ');
    $00515151:writeln(f,i,' ',j,' ',22,' ');
    $00616161:writeln(f,i,' ',j,' ',23,' ');
    $00717171:writeln(f,i,' ',j,' ',24,' ');
    $00828282:writeln(f,i,' ',j,' ',25,' ');

    $00929292:writeln(f,i,' ',j,' ',26,' ');
    $00A2A2A2:writeln(f,i,' ',j,' ',27,' ');
    $00B6B6B6:writeln(f,i,' ',j,' ',28,' ');
    $00CBCBCB:writeln(f,i,' ',j,' ',29,' ');
    $00E3E3E3:writeln(f,i,' ',j,' ',30,' ');

    $FF0000:writeln(f,i,' ',j,' ',32,' ');
    $00FF0041:writeln(f,i,' ',j,' ',33,' ');
    $00FF0080:writeln(f,i,' ',j,' ',34,' ');
    $00FF00BE:writeln(f,i,' ',j,' ',35,' ');
    $FF00FF:writeln(f,i,' ',j,' ',36,' ');

    $00BE00FF:writeln(f,i,' ',j,' ',37,' ');
    $007D00FF:writeln(f,i,' ',j,' ',38,' ');
    $004100FF:writeln(f,i,' ',j,' ',39,' ');
    $0000FF:writeln(f,i,' ',j,' ',40,' ');
    $000041FF:writeln(f,i,' ',j,' ',41,' ');

    $00007DFF:writeln(f,i,' ',j,' ',42,' ');
    $0000BEFF:writeln(f,i,' ',j,' ',43,' ');
    $00FFFF:writeln(f,i,' ',j,' ',44,' ');
    $0000FFBE:writeln(f,i,' ',j,' ',45,' ');
    $0000FF7D:writeln(f,i,' ',j,' ',46,' ');

    $0000FF41:writeln(f,i,' ',j,' ',47,' ');
    $00FF00:writeln(f,i,' ',j,' ',48,' ');
    $0041FF00:writeln(f,i,' ',j,' ',49,' ');
    $007DFF00:writeln(f,i,' ',j,' ',50,' ');
    $00BEFF00:writeln(f,i,' ',j,' ',51,' ');

    $00FFFF00:writeln(f,i,' ',j,' ',52,' ');
    $00FFBE00:writeln(f,i,' ',j,' ',53,' ');
    $00FF7D00:writeln(f,i,' ',j,' ',54,' ');
    $00FF4100:writeln(f,i,' ',j,' ',55,' ');
    $00FF7D7D:writeln(f,i,' ',j,' ',56,' ');

    $00FF7D9E:writeln(f,i,' ',j,' ',57,' ');
    $00FF7DBE:writeln(f,i,' ',j,' ',58,' ');
    $00FF7DDF:writeln(f,i,' ',j,' ',59,' ');
    $00FF7DFF:writeln(f,i,' ',j,' ',60,' ');
    $00DF7DFF:writeln(f,i,' ',j,' ',61,' ');

    $00BE7DFF:writeln(f,i,' ',j,' ',62,' ');
    $009E7DFF:writeln(f,i,' ',j,' ',63,' ');
    $007D7DFF:writeln(f,i,' ',j,' ',64,' ');
    $007D9EFF:writeln(f,i,' ',j,' ',65,' ');
    $007DBEFF:writeln(f,i,' ',j,' ',66,' ');

    $007DDFFF:writeln(f,i,' ',j,' ',67,' ');
    $007DFFFF:writeln(f,i,' ',j,' ',68,' ');
    $007DFFDF:writeln(f,i,' ',j,' ',69,' ');
    $007DFFBE:writeln(f,i,' ',j,' ',70,' ');
    $007DFF9E:writeln(f,i,' ',j,' ',71,' ');

    $007DFF7D:writeln(f,i,' ',j,' ',72,' ');
    $009EFF7D:writeln(f,i,' ',j,' ',73,' ');
    $00BEFF7D:writeln(f,i,' ',j,' ',74,' ');
    $00DFFF7D:writeln(f,i,' ',j,' ',75,' ');
    $00FFFF7D:writeln(f,i,' ',j,' ',76,' ');

    $00FFDF7D:writeln(f,i,' ',j,' ',77,' ');
    $00FFBE7D:writeln(f,i,' ',j,' ',78,' ');
    $00FF9E7D:writeln(f,i,' ',j,' ',79,' ');
    $00FFB6B6:writeln(f,i,' ',j,' ',80,' ');
    $00FFB6C7:writeln(f,i,' ',j,' ',81,' ');

    $00FFB6DB:writeln(f,i,' ',j,' ',82,' ');
    $00FFB6EB:writeln(f,i,' ',j,' ',83,' ');
    $00FFB6FF:writeln(f,i,' ',j,' ',84,' ');
    $00EBB6FF:writeln(f,i,' ',j,' ',85,' ');
    $00DBB6FF:writeln(f,i,' ',j,' ',86,' ');

    $00C7B6FF:writeln(f,i,' ',j,' ',87,' ');
    $00B6B6FF:writeln(f,i,' ',j,' ',88,' ');
    $00B6C7FF:writeln(f,i,' ',j,' ',89,' ');
    $00B6DBFF:writeln(f,i,' ',j,' ',90,' ');
    $00B6EBFF:writeln(f,i,' ',j,' ',91,' ');

    $00B6FFFF:writeln(f,i,' ',j,' ',92,' ');
    $00B6FFEB:writeln(f,i,' ',j,' ',93,' ');
    $00B6FFDB:writeln(f,i,' ',j,' ',94,' ');
    //load
    $00B6FFC7:writeln(f,i,' ',j,' ',95,' ');
    $00B6FFB6:writeln(f,i,' ',j,' ',96,' ');

    $00C7FFB6:writeln(f,i,' ',j,' ',97,' ');
    $00DBFFB6:writeln(f,i,' ',j,' ',98,' ');
    $00EBFFB6:writeln(f,i,' ',j,' ',99,' ');
    $00FFFFB6:writeln(f,i,' ',j,' ',100,' ');
    $00FFEBB6:writeln(f,i,' ',j,' ',101,' ');

    $00FFDBB6:writeln(f,i,' ',j,' ',102,' ');
    $00FFC7B6:writeln(f,i,' ',j,' ',103,' ');
    $00710000:writeln(f,i,' ',j,' ',104,' ');
    $0071001C:writeln(f,i,' ',j,' ',105,' ');
    $00710038:writeln(f,i,' ',j,' ',106,' ');

    $00710055:writeln(f,i,' ',j,' ',107,' ');
    $00710071:writeln(f,i,' ',j,' ',108,' ');
    $00550071:writeln(f,i,' ',j,' ',109,' ');
    $00380071:writeln(f,i,' ',j,' ',110,' ');
    $001C0071:writeln(f,i,' ',j,' ',111,' ');

    $00000071:writeln(f,i,' ',j,' ',112,' ');
    $00001C71:writeln(f,i,' ',j,' ',113,' ');
    $00003871:writeln(f,i,' ',j,' ',114,' ');
    $00005571:writeln(f,i,' ',j,' ',115,' ');
    $00007171:writeln(f,i,' ',j,' ',116,' ');

    $00007155:writeln(f,i,' ',j,' ',117,' ');
    $00007138:writeln(f,i,' ',j,' ',118,' ');
    $0000711C:writeln(f,i,' ',j,' ',119,' ');
    $00007100:writeln(f,i,' ',j,' ',120,' ');
    $001C7100:writeln(f,i,' ',j,' ',121,' ');

    $00387100:writeln(f,i,' ',j,' ',122,' ');
    $00557100:writeln(f,i,' ',j,' ',123,' ');
    $00717100:writeln(f,i,' ',j,' ',124,' ');
    $00715500:writeln(f,i,' ',j,' ',125,' ');
    $00713800:writeln(f,i,' ',j,' ',126,' ');

    $00711C00:writeln(f,i,' ',j,' ',127,' ');
    $00713838:writeln(f,i,' ',j,' ',128,' ');
    $00713845:writeln(f,i,' ',j,' ',129,' ');
    $00713855:writeln(f,i,' ',j,' ',130,' ');
    $00713861:writeln(f,i,' ',j,' ',131,' ');

    $00713871:writeln(f,i,' ',j,' ',132,' ');
    $00613871:writeln(f,i,' ',j,' ',133,' ');
    $00553871:writeln(f,i,' ',j,' ',134,' ');
    $00453871:writeln(f,i,' ',j,' ',135,' ');
    $00383871:writeln(f,i,' ',j,' ',136,' ');

    $00384571:writeln(f,i,' ',j,' ',137,' ');
    $00385571:writeln(f,i,' ',j,' ',138,' ');
    $00386171:writeln(f,i,' ',j,' ',139,' ');
    $00387171:writeln(f,i,' ',j,' ',140,' ');
    $00387161:writeln(f,i,' ',j,' ',141,' ');

    $00387155:writeln(f,i,' ',j,' ',142,' ');
    $00387145:writeln(f,i,' ',j,' ',143,' ');
    $00387138:writeln(f,i,' ',j,' ',144,' ');
    $00457138:writeln(f,i,' ',j,' ',145,' ');
    $00557138:writeln(f,i,' ',j,' ',146,' ');

    $00617138:writeln(f,i,' ',j,' ',147,' ');
    $00717138:writeln(f,i,' ',j,' ',148,' ');
    $00716138:writeln(f,i,' ',j,' ',149,' ');
    $00715538:writeln(f,i,' ',j,' ',150,' ');
    $00714538:writeln(f,i,' ',j,' ',151,' ');

    $00715151:writeln(f,i,' ',j,' ',152,' ');
    $00715159:writeln(f,i,' ',j,' ',153,' ');
    $00715161:writeln(f,i,' ',j,' ',154,' ');
    $00715169:writeln(f,i,' ',j,' ',155,' ');
    $00715171:writeln(f,i,' ',j,' ',156,' ');

    $00695171:writeln(f,i,' ',j,' ',157,' ');
    $00615171:writeln(f,i,' ',j,' ',158,' ');
    $00595171:writeln(f,i,' ',j,' ',159,' ');
    $00515171:writeln(f,i,' ',j,' ',160,' ');
    $00515971:writeln(f,i,' ',j,' ',161,' ');

    $00516171:writeln(f,i,' ',j,' ',162,' ');
    $00516971:writeln(f,i,' ',j,' ',163,' ');
    $00517171:writeln(f,i,' ',j,' ',164,' ');
    $00517169:writeln(f,i,' ',j,' ',165,' ');
    $00517161:writeln(f,i,' ',j,' ',166,' ');

    $00517159:writeln(f,i,' ',j,' ',167,' ');
    $00517151:writeln(f,i,' ',j,' ',168,' ');
    $00597151:writeln(f,i,' ',j,' ',169,' ');
    $00617151:writeln(f,i,' ',j,' ',170,' ');
    $00697151:writeln(f,i,' ',j,' ',171,' ');

    $00717151:writeln(f,i,' ',j,' ',172,' ');
    $00716951:writeln(f,i,' ',j,' ',173,' ');
    $00716151:writeln(f,i,' ',j,' ',174,' ');
    $00715951:writeln(f,i,' ',j,' ',175,' ');
    $00410000:writeln(f,i,' ',j,' ',176,' ');

    $00410010:writeln(f,i,' ',j,' ',177,' ');
    $00410020:writeln(f,i,' ',j,' ',178,' ');
    $00410030:writeln(f,i,' ',j,' ',179,' ');
    $00410041:writeln(f,i,' ',j,' ',180,' ');
    $00300041:writeln(f,i,' ',j,' ',181,' ');

    $00200041:writeln(f,i,' ',j,' ',182,' ');
    $00100041:writeln(f,i,' ',j,' ',183,' ');
    $00000041:writeln(f,i,' ',j,' ',184,' ');
    $00001041:writeln(f,i,' ',j,' ',185,' ');
    $00002041:writeln(f,i,' ',j,' ',186,' ');

    $00003041:writeln(f,i,' ',j,' ',187,' ');
    $00004141:writeln(f,i,' ',j,' ',188,' ');
    $00004130:writeln(f,i,' ',j,' ',189,' ');
    $00004120:writeln(f,i,' ',j,' ',190,' ');
    $00004110:writeln(f,i,' ',j,' ',191,' ');

    $00004100:writeln(f,i,' ',j,' ',192,' ');
    $00104100:writeln(f,i,' ',j,' ',193,' ');
    $00204100:writeln(f,i,' ',j,' ',194,' ');
    $00304100:writeln(f,i,' ',j,' ',195,' ');
    $00414100:writeln(f,i,' ',j,' ',196,' ');

    $00413000:writeln(f,i,' ',j,' ',197,' ');
    $00412000:writeln(f,i,' ',j,' ',198,' ');
    $00411000:writeln(f,i,' ',j,' ',199,' ');
    $00412020:writeln(f,i,' ',j,' ',200,' ');
    $00412028:writeln(f,i,' ',j,' ',201,' ');

    $00412030:writeln(f,i,' ',j,' ',202,' ');
    $00412038:writeln(f,i,' ',j,' ',203,' ');
    $00412041:writeln(f,i,' ',j,' ',204,' ');
    $00382041:writeln(f,i,' ',j,' ',205,' ');
    $00302041:writeln(f,i,' ',j,' ',206,' ');

    $00282041:writeln(f,i,' ',j,' ',207,' ');
    $00202041:writeln(f,i,' ',j,' ',208,' ');
    $00202841:writeln(f,i,' ',j,' ',209,' ');
    $00203041:writeln(f,i,' ',j,' ',210,' ');
    $00203841:writeln(f,i,' ',j,' ',211,' ');

    $00204141:writeln(f,i,' ',j,' ',212,' ');
    $00204138:writeln(f,i,' ',j,' ',213,' ');
    $00204130:writeln(f,i,' ',j,' ',214,' ');
    $00204128:writeln(f,i,' ',j,' ',215,' ');
    $00204120:writeln(f,i,' ',j,' ',216,' ');

    $00284120:writeln(f,i,' ',j,' ',217,' ');
    $00304120:writeln(f,i,' ',j,' ',218,' ');
    $00384120:writeln(f,i,' ',j,' ',219,' ');
    $00414120:writeln(f,i,' ',j,' ',220,' ');
    $00413820:writeln(f,i,' ',j,' ',221,' ');

    $00413020:writeln(f,i,' ',j,' ',222,' ');
    $00412820:writeln(f,i,' ',j,' ',223,' ');
    $00412C2C:writeln(f,i,' ',j,' ',224,' ');
    $00412C30:writeln(f,i,' ',j,' ',225,' ');
    $00412C34:writeln(f,i,' ',j,' ',226,' ');

    $00412C3C:writeln(f,i,' ',j,' ',227,' ');
    $00412C41:writeln(f,i,' ',j,' ',228,' ');
    $003C2C41:writeln(f,229,' ');
    $00342C41:writeln(f,i,' ',j,' ',230,' ');
    $00302C41:writeln(f,i,' ',j,' ',231,' ');

    $002C2C41:writeln(f,i,' ',j,' ',232,' ');
    $002C3041:writeln(f,i,' ',j,' ',233,' ');
    $002C3441:writeln(f,i,' ',j,' ',234,' ');
    $002C3C41:writeln(f,i,' ',j,' ',235,' ');
    $002C4141:writeln(f,i,' ',j,' ',236,' ');

    $002C413C:writeln(f,i,' ',j,' ',237,' ');
    $002C4134:writeln(f,i,' ',j,' ',238,' ');
    $002C4130:writeln(f,i,' ',j,' ',239,' ');
    $002C412C:writeln(f,i,' ',j,' ',240,' ');
    $0030412C:writeln(f,i,' ',j,' ',241,' ');

    $0034412C:writeln(f,i,' ',j,' ',242,' ');
    $003C412C:writeln(f,i,' ',j,' ',243,' ');
    $0041412C:writeln(f,i,' ',j,' ',244,' ');
    $00413C2C:writeln(f,i,' ',j,' ',245,' ');
    $0041342C:writeln(f,i,' ',j,' ',246,' ');

   end;
  end;
 writeln('File was succesfully converted, TDI file name - ',fname,'.TDI')
 except
 writeln('Error!!! Source file doesnt founded in converter root directory...');
 end;

 Bitmap.free;
 Close(f);

writeln('Press Any Key For Exit...');
readln;
end.
